
;****************************************************
;
;******************* FREEZER RECEIVER *****************
;
;
;****************************************************
  

;01/08/2011
;XTAL 4 MHz
;USE RS232 2400 BAUD 


;ALARM WILL REMAIN ON EVEN THOUGH TEMPERATURE OR POWER LIGHTS ARE GREEN
;SHOWING THAT ALARM HAS OCCURED.  

;PIN 1 VCC
;PIN 2 RB5 	  LED1   
;PIN 3 RB4    LED2                  
;PIN 4 RB3    DATA_IN
;PIN 5 RB2    SWITCH (RESET)     
;PIN 6 RB1	  SOUND
;PIN 7 RB0	  COMMON
;PIN 8 VSS
	RADIX		HEX	;HEX IS DEFAULT # FORMAT
    list      p=12F675            ; list directive to define processor
    #include <p12F675.inc>        ; processor specific variable definitions
   __CONFIG _CP_OFF & _BODEN_OFF & _PWRTE_OFF & _MCLRE_OFF &_WDT_OFF & _INTRC_OSC_NOCLKOUT
 
TEMP           	EQU		20H		  	;WORKING REGISTER
DELAY_CNTR     	EQU     21H       	;COUNTING REGISTER FOR RS232
BIT_CNTR1     	EQU     22H       	;COUNTING REGISTER FOR RS232
BIT_CNTR       	EQU     23H       	;COUNTING REGISTER FOR RS232
RCV_BYTE       	EQU     24H       	;TRANSFER REGISTER FOR RS232
RCV_BYTE1      	EQU     25H       	;TRANSFER REGISTER FOR RS232
KEY1		   	EQU		26H			;KEY 1 FOR RECEIVER
FLAGS			EQU		27H			;FLAG REGISTER
w_temp        	EQU     28H         ; variable used for context saving 
status_temp   	EQU     29H         ; variable used for context saving
RESULTS			EQU		2AH			;RESULTS REGISTER
WAIT			EQU		2BH			;WAIT REGISTER


#DEFINE		   DATA_IN      GPIO,3     	;RS232 DATA IN
#DEFINE		   LED1			GPIO,5		;BI COLORED LED
#DEFINE		   LED2			GPIO,4		;BI COLORED LED
#DEFINE		   COMMON		GPIO,0		;LED COMMON
#DEFINE		   SOUND		GPIO,1		;ALARM NOISE
#DEFINE		   SWITCH		GPIO,2		;RESET SWITCH
		ORG	00H
		GOTO		MAIN

		ORG     0x004             ; interrupt vector location
INTERRUPT	
		movwf   w_temp            ; save off current W register contents
		movf	STATUS,w          ; move status register into W register
		movwf	status_temp       ; save off contents of STATUS register
		BCF		FLAGS,0			  ; RESET FLAG,0
		BCF		SOUND			  ; TURN OFF SOUND
		MOVF	GPIO,1			  ; RELOAD TO DETECT CHANGE
		BCF		INTCON,INTF		  ; CLEAR FLAG
		movf    status_temp,w     ; retrieve copy of STATUS register
		movwf	STATUS            ; restore pre-isr STATUS register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt


 

;********INPUT KEY 1 IN HEXIDECIMAL E.G.0A1H
MAIN 		MOVLW		0AAH		;LOADING KEY 1
			MOVWF		KEY1		;LOAD


AWAYWEGO								;LABLE
 	   	CLRF		GPIO				;CLEAR PINS
		MOVLW		B'00000111'
		MOVWF		CMCON
        BSF   		STATUS, RP0        	;JUMP TO PAGE 1
	  	MOVLW		B'00001100'			;LOAD PINS FOR IN AND OUT
	 	MOVWF		TRISIO				;LOAD
		MOVLW		.0					;LOAD OPTION
        MOVWF		OPTION_REG		   	;LOAD
		CLRF		ANSEL        		;LOAD
		MOVLW		B'11010000'			;LOAD INTCON
		MOVWF   	INTCON				;LOAD
		MOVLW		B'00000100'			;LOAD IOC GP2 INTERRUPT
		MOVWF		IOC					;LOAD
		MOVLW		B'00000100'			;LOAD WPU GP2 PULL UP
		MOVWF		WPU					;LOAD
		CLRF		PIE1				;LOAD
       	BCF 	   	STATUS,RP0       	;BACK TO PAGE 0
		CLRF		RESULTS				;CLEAR RESULTS
		CLRF		FLAGS				;CELAR FLAGS
		CLRF		GPIO				;CLEAR ALL PINS OUT
;*************************TESTING AREA ********************
TESTING


;*******************DISPLAYING OF RESULTS AND ALARMS ********************
START
		MOVLW		.0					;CHECK IF RESULTS = 0
		SUBWF		RESULTS,0
		BTFSC		3,2
		GOTO        GREEN_GREEN			;= 0 JUMP

		MOVLW		.1					;CHECK IF RESULTS = 1
		SUBWF		RESULTS,0
		BTFSC		3,2
		GOTO		RED_GREEN			;= 1 JUMP

		MOVLW		.2					;CHECK IF RESULTS = 2
		SUBWF		RESULTS,0
		BTFSC		3,2
		GOTO		GREEN_RED			;= 2 JUMP

		MOVLW		.3					;CHECK IF RESULTS = 3
		SUBWF		RESULTS,0
		BTFSC		3,2
		GOTO		RED_RED				;= 3 JUMP	

GREEN_GREEN
		BSF			STATUS,RP0			;CHANGE PAGE
	  	MOVLW		B'00001100'			;LOAD PINS FOR IN AND OUT
		MOVWF		TRISIO				;LOAD
		BCF			STATUS,RP0			;CHANGE PAGE
		BCF			LED1				;LED1 GREEN
		BCF			LED2				;LED2 GREEN
		BSF			COMMON				;COMMON HIGH
		GOTO		ALARM				;JUMP TO ALARM

RED_RED	
		BSF			STATUS,RP0			;CHANGE PAGE
	  	MOVLW		B'00001100'			;LOAD PINS FOR IN AND OUT
		MOVWF		TRISIO				;LOAD
		BCF			STATUS,RP0			;CHANGE PAGE
		BSF			LED1				;LED1 RED
		BSF			LED2				;LED2 RED
		BCF			COMMON				;COMMON GROUND
		BSF			FLAGS,0				;SET ALARM FLAG
		GOTO		ALARM				;JUMP TO ALARM

GREEN_RED
		BSF			STATUS,RP0			;CHANGE PAGE
	  	MOVLW		B'00001101'			;LOAD PINS FOR IN AND OUT
		MOVWF		TRISIO				;LOAD
		BCF			STATUS,RP0			;CHANGE PAGE
		BCF			LED1				;LED1 GREEN
		BSF			LED2				;LED2 RED
		BSF			FLAGS,0				;SET ALARM FLAG
		GOTO		ALARM				;JUMP TO ALARM

RED_GREEN
		BSF			STATUS,RP0			;CHANGE PAGE
	  	MOVLW		B'00001101'			;LOAD PINS FOR IN AND OUT
		MOVWF		TRISIO				;LOAD
		BCF			STATUS,RP0			;CHANGE PAGE
		BSF			LED1				;LED1 RED
		BCF			LED2				;LED2 GREEN
		BSF			FLAGS,0				;SET ALARM FLAG

ALARM	BTFSC		FLAGS,0			
		GOTO		S0
		BCF			SOUND			;TURN OFF SOUND
		GOTO		S1
S0		BSF			SOUND			;TURN ON SOUND

;*************THIS AREA ELIMINATES FALSE SIGNALS******************	
S1		MOVLW		.16				;LOADING 16 INTO WAIT
		MOVWF		WAIT			;LOAD
		
C1	 	BTFSS		DATA_IN			;MAKE SURE DATA IN IS HIGH FOR A PERIOD OF TIME INDICATING TRANSMITTER SIGNAL
	  	GOTO		S1				;NOT HIGH CHECK AGAIN		
		CALL		BIT_DELAY		;CALLING BIT DELAY
		DECFSZ		WAIT,1			;TIMER FOR CHECKING FOR 8 BIT DELAYS
		GOTO		C1				;JUMP AND CHECK DATA IO DO FOR 16 BIT DELAYS
C0	  	BTFSC		DATA_IN			;CHECK FOR START SIGNAL FROM TRANSMITTER
		GOTO		C0				;NO DATA GO TO CO  
		CALL		START_DELAY		;START PULSE CHECKING TO SEE IF VALID
		BTFSC		DATA_IN			;STILL LOW? SETTING TO 1/2 BIT DELAY
		GOTO		S1				;START OVER AGAIN

	    
;********************READING DATA *****************************
		MOVLW		.8				;LOAD BIT COUNTERS
		MOVWF		BIT_CNTR		;LOAD
		MOVWF		BIT_CNTR1		;LOAD
		CLRF		RCV_BYTE		;CLEAR RCV BYTE
		CLRF		RCV_BYTE1		;CLEAR RCV BYTE 1

NEXT_RCVBIT							;LABEL
		CALL		BIT_DELAY		;CALLING BIT DELAY
		BTFSS		DATA_IN			;IS DATA IN HIGH?
		BCF			STATUS,C		;NO CLEAR STATUS C
		BTFSC		DATA_IN			;IS DATE LOW?
		BSF			STATUS,C		;NOT SET STATUS C
		RRF			RCV_BYTE,1		;ROTATE RECEIVE BYTE OUT
		DECFSZ		BIT_CNTR,1		;CHECK TO SEE IF 8 BITS SENT
		GOTO		NEXT_RCVBIT		;NOT 8 DO AGAIN

NEXT_RCVBIT1						;LABEL
		CALL		BIT_DELAY		;CALL BIT DELAY
		BTFSS		DATA_IN			;CHECK SERIAL IN
		BCF			STATUS,C		;LOW CLEAR STATUS C
		BTFSC		DATA_IN			;CHECK SERIAL IN
		BSF			STATUS,C		;HIGH SET STATUS C
		RRF			RCV_BYTE1,1		;ROTATE BIT OUT
		DECFSZ		BIT_CNTR1,1		;CHECK FOR 8 BITS
		GOTO		NEXT_RCVBIT1	;NOT 8 BITS DO AGAIN

DECODE	MOVF		KEY1,0			;MOVE KEY1 INTO W
		SUBWF		RCV_BYTE,0		;SUBTRACT TRANSMITTED KEY
		BTFSC		3,2				;CHECK TO SEE IF IDENTICAL
		GOTO		D1				;IDENTICAL GO TO D1
		GOTO		S1				;DID NOT MATCH START OVER

D1		MOVF		RCV_BYTE1,0		;MOVE RCV BYTE 1 INTO RESULTS
		MOVWF		RESULTS			;LOAD
		GOTO		START

;********************RS232 INSTRUCTIONS***********
       
BIT_DELAY 
		MOVLW		D'200'		    ;SETUP FOR 1200 BAUD
		MOVWF		DELAY_CNTR      ;DELAY LOOP
LOOP_1  NOP							;DELAY HELP
		DECFSZ  	DELAY_CNTR,1	;DECREASING COUNTER		
		GOTO		LOOP_1    		;DECREASE COUNTER
		RETLW 	    0               ;RETURN TO CALL

START_DELAY							;LABEL
		MOVLW		D'100'		   	;SETUP FOR 1200 BAUD SETS FOR DETECTING MIDDLE OF BIT
		MOVWF		DELAY_CNTR	   	;DELAY LOOP
		
LOOP_2	NOP							;DELAY HELP
		DECFSZ		DELAY_CNTR,1	;DECREASEING COUNTER
	    GOTO		LOOP_2          ;DECREASE COUNTER
        RETLW 		0              	;RETURN TO CALL

		END			;END OF PROGRAM